<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 10/04/19
 * Time: 11.09
 */

namespace FiloBlu\DisableRmaPersonalizedOrder\Plugin;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\Message\ManagerInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Sales\Model\OrderRepository;
use Magento\Framework\Controller\ResultFactory;
use Magento\Backend\App\Action\Context;
use Magento\Framework\App\Action\Action;

class DisablePersonalizedOrderRma extends Action
{
    protected $messageManager;
    protected $request;
    protected $orderRepository;
    protected $resultFactory;
    protected $scopeConfig;
    const RMA_CONFIG_PATH = 'filoblu_disablerma_section/rma_group/rma_option_id';

    /**
     * DisablePersonalizedOrderRma constructor.
     * @param Context $context
     * @param ManagerInterface $messageManager
     * @param RequestInterface $request
     * @param OrderRepository $orderRepository
     * @param ResultFactory $resultFactory
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(Context $context,
                                ManagerInterface $messageManager,
                                RequestInterface $request,
                                OrderRepository $orderRepository,
                                ResultFactory $resultFactory,
                                ScopeConfigInterface $scopeConfig)
    {

        $this->messageManager = $messageManager;
        $this->request = $request;
        $this->orderRepository = $orderRepository;
        $this->resultFactory = $resultFactory;
        $this->scopeConfig = $scopeConfig;
    }



    public function afterExecute()
    {

        //exec only if config is enabled
        if($this->scopeConfig->getValue(self::RMA_CONFIG_PATH))
        {
            $orderId = (int)$this->request->getParam('order_id');
            try
            {
                $order = $this->orderRepository->get($orderId);
                $allItems = $order->getAllItems();
                $options = "";
                foreach ($allItems as $item)
                {
                    $options = $item->getProductOptions();
                }
                if(isset($options['options']))
                {
                    $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);

                    $resultRedirect->setPath("sales/order/view/order_id/$orderId");
                    //personalizzato
                    $this->messageManager->addErrorMessage("Rma not applicable on personalized orders.");
                    return $resultRedirect;
                }
                else
                {
                    //non fare nulla
                    $ciao="";
                }
            }
            catch (\Exception $e)
            {
                $this->messageManager->addErrorMessage("Error: $e");
            }
        }



    }

    public function execute()
    {
        // TODO: Implement execute() method.
    }


}